# [PATCH] git-submodule: abort if core.worktree could not be set correctly

3 messages from 2019-01-18 to 2019-01-18. Participants: Stefan Beller, Junio C Hamano.
Thread: https://gitlist.dev/t/50263

## Stefan Beller, 2019-01-18 21:55

Subject: [PATCH] git-submodule: abort if core.worktree could not be set correctly
Message-ID: <20190118215519.107700-1-sbeller@google.com>
URL: https://gitlist.dev/e/20190118215519.107700-1-sbeller%40google.com

```
74d4731da1f (submodule--helper: replace connect-gitdir-workingtree by
ensure-core-worktree, 2018-08-13) forgot to exit the submodule operation
if the helper could not ensure that core.worktree is set correctly.

Signed-off-by: Stefan Beller <sbeller@google.com>
---
 git-submodule.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/git-submodule.sh b/git-submodule.sh
index 5e608f8bad3..02a0d728174 100755
--- a/git-submodule.sh
+++ b/git-submodule.sh
@@ -548,7 +548,7 @@ cmd_update()
 	do
 		die_if_unmatched "$quickabort" "$sha1"
 
-		git submodule--helper ensure-core-worktree "$sm_path"
+		git submodule--helper ensure-core-worktree "$sm_path" || exit 1
 
 		update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
 
-- 
2.20.1.101.g27c53b536e7.dirty


```

## Junio C Hamano, 2019-01-18 23:18

Subject: Re: [PATCH] git-submodule: abort if core.worktree could not be set correctly
Message-ID: <xmqqlg3himh8.fsf@gitster-ct.c.googlers.com>
URL: https://gitlist.dev/e/xmqqlg3himh8.fsf%40gitster-ct.c.googlers.com
In-Reply-To: <20190118215519.107700-1-sbeller@google.com>

```
Stefan Beller <sbeller@google.com> writes:

> 74d4731da1f (submodule--helper: replace connect-gitdir-workingtree by
> ensure-core-worktree, 2018-08-13) forgot to exit the submodule operation
> if the helper could not ensure that core.worktree is set correctly.
>
> Signed-off-by: Stefan Beller <sbeller@google.com>
> ---
>  git-submodule.sh | 2 +-
>  1 file changed, 1 insertion(+), 1 deletion(-)
>
> diff --git a/git-submodule.sh b/git-submodule.sh
> index 5e608f8bad3..02a0d728174 100755
> --- a/git-submodule.sh
> +++ b/git-submodule.sh
> @@ -548,7 +548,7 @@ cmd_update()
>  	do
>  		die_if_unmatched "$quickabort" "$sha1"
>  
> -		git submodule--helper ensure-core-worktree "$sm_path"
> +		git submodule--helper ensure-core-worktree "$sm_path" || exit 1

Good to have more places check errors from underlying command.

Thanks.

Out of curiousity, was this found by code inspection, or was there a
real-world breakage episode?


```

## Stefan Beller, 2019-01-18 23:30

Subject: Re: [PATCH] git-submodule: abort if core.worktree could not be set correctly
Message-ID: <CAGZ79kY=LOmzQXja6mUiBOSSrmjvGsRDWzzXsq9vMsYWRw02Pw@mail.gmail.com>
URL: https://gitlist.dev/e/CAGZ79kY%3DLOmzQXja6mUiBOSSrmjvGsRDWzzXsq9vMsYWRw02Pw%40mail.gmail.com
In-Reply-To: <xmqqlg3himh8.fsf@gitster-ct.c.googlers.com>

```
On Fri, Jan 18, 2019 at 3:18 PM Junio C Hamano <gitster@pobox.com> wrote:
>
> Stefan Beller <sbeller@google.com> writes:
>
> > 74d4731da1f (submodule--helper: replace connect-gitdir-workingtree by
> > ensure-core-worktree, 2018-08-13) forgot to exit the submodule operation
> > if the helper could not ensure that core.worktree is set correctly.
> >
> > Signed-off-by: Stefan Beller <sbeller@google.com>
> > ---
> >  git-submodule.sh | 2 +-
> >  1 file changed, 1 insertion(+), 1 deletion(-)
> >
> > diff --git a/git-submodule.sh b/git-submodule.sh
> > index 5e608f8bad3..02a0d728174 100755
> > --- a/git-submodule.sh
> > +++ b/git-submodule.sh
> > @@ -548,7 +548,7 @@ cmd_update()
> >       do
> >               die_if_unmatched "$quickabort" "$sha1"
> >
> > -             git submodule--helper ensure-core-worktree "$sm_path"
> > +             git submodule--helper ensure-core-worktree "$sm_path" || exit 1
>
> Good to have more places check errors from underlying command.
>
> Thanks.
>
> Out of curiousity, was this found by code inspection, or was there a
> real-world breakage episode?

By code inspection to come up with an answer for
https://public-inbox.org/git/CAG0vfyQeA3Hm7AsYgYtP4v-Yg0=rKXW0YYfg_emAwEscZha4VA@mail.gmail.com/

That issue in itself is not fully solved (Duy is still looking into it),
but this fixes a minor inconsistency along the way.

```
